<?xml version="1.0" encoding="UTF-8"?>
<EventSpec
    xmlns="http://www.ibm.com/xmlns/prod/websphere/monitoring/6.0.0/es"
    xmlns:er="http://www.ibm.com/xmlns/prod/websphere/monitoring/6.0.0/es/eventpayloads"

    name="Events"
    targetNamespace="http://www.ibm.com/xmlns/prod/websphere/wbiserver/ifm/6.0.0:InterfaceMediation"
    >


    <Events>
        <Event name="WBI.MEDIATION.OperationBinding.ENTRY" parent="WBI.MonitoringEvent" situationType="STATUS" situationCategory="ReportSituation" reasoningScope="EXTERNAL">
            <Payload>
                <Data name="InteractionType" type="string" minOccurs="0" maxOccurs="1"/>
                <Data name="TicketID" type="string" minOccurs="0" maxOccurs="1"/>
                <Data name="Source" type="string" minOccurs="1" maxOccurs="1"/>
                <Data name="Target" type="string" minOccurs="1" maxOccurs="1"/>
                <Data role="Input" type="primitive businessObject" maxOccurs="unbounded"/>
                <!-- the SPI allows the client code to provide the param names, these will be used instead of the role -->
            </Payload>
        </Event>
        <Event name="WBI.MEDIATION.OperationBinding.EXIT" parent="WBI.MonitoringEvent" situationType="STATUS" situationCategory="ReportSituation" reasoningScope="EXTERNAL">
            <Payload>
                <Data name="InteractionType" type="string" minOccurs="0" maxOccurs="1"/>
                <Data name="TicketID" type="string" minOccurs="0" maxOccurs="1"/>
                <Data name="Source" type="string" minOccurs="1" maxOccurs="1"/>
                <Data name="Target" type="string" minOccurs="1" maxOccurs="1"/>
                <Data role="Output" type="primitive businessObject" minOccurs="0" maxOccurs="1"/>
                <!-- the SPI allows the client code to provide the param names, these will be used instead of the role -->
            </Payload>
        </Event>
        <Event name="WBI.ER" refName="WBI.ErrorReport" from="er:ITEvents"/>
        <Event name="WBI.MEDIATION.OperationBinding.FAILURE" parent="WBI.ER" situationType="STATUS" situationCategory="ReportSituation" reasoningScope="EXTERNAL">
            <Payload>
                <Data name="InteractionType" type="string" minOccurs="0" maxOccurs="1"/>
                <Data name="TicketID" type="string" minOccurs="0" maxOccurs="1"/>
                <Data name="Source" type="string" minOccurs="1" maxOccurs="1"/>
                <Data name="Target" type="string" minOccurs="1" maxOccurs="1"/>
                <Data role="Input" type="primitive businessObject" minOccurs="0" maxOccurs="unbounded"/>
            </Payload>
        </Event>

        <Event name="WBI.MEDIATION.ParameterMediation.ENTRY" parent="WBI.MonitoringEvent" situationType="STATUS" situationCategory="ReportSituation" reasoningScope="EXTERNAL">
            <Payload name="DEFAULT">
                <Data name="Type" type="string" minOccurs="1" maxOccurs="1"/>
                <Data name="TransformName" type="string" minOccurs="1" maxOccurs="1"/>
                <Data role="Input" type="primitive businessObject" minOccurs="0" maxOccurs="unbounded"/>
            </Payload>
        </Event>
        <Event name="WBI.MEDIATION.ParameterMediation.EXIT" parent="WBI.MonitoringEvent" situationType="STATUS" situationCategory="ReportSituation" reasoningScope="EXTERNAL">
            <Payload>
                <Data name="Type" type="string" minOccurs="1" maxOccurs="1"/>
                <Data name="TransformName" type="string" minOccurs="1" maxOccurs="1"/>
                <Data role= "Output" type="primitive businessObject" maxOccurs="1"/>
            </Payload>
        </Event>
        <Event name="WBI.MEDIATION.ParameterMediation.FAILURE" parent="WBI.ER" situationType="STATUS" situationCategory="ReportSituation" reasoningScope="EXTERNAL">
            <Payload>
                <Data name="Type" type="string" minOccurs="1" maxOccurs="1"/>
                <Data name="TransformName" type="string" minOccurs="1" maxOccurs="1"/>
                <Data role="Input" type="primitive businessObject" minOccurs="0" maxOccurs="unbounded"/>
            </Payload>
        </Event>
    </Events>
</EventSpec>

