<?xml version="1.0" encoding="UTF-8"?>
<EventSpec
    xmlns="http://www.ibm.com/xmlns/prod/websphere/monitoring/6.0.0/es"
    xmlns:er="http://www.ibm.com/xmlns/prod/websphere/monitoring/6.0.0/es/eventpayloads"
    name="Events"
    targetNamespace="http://www.ibm.com/xmlns/prod/websphere/wbi/sacl/6.0.0:tStateMachineDefinition"
    >

    <Events>
        <Event name="WBI.BSM.StateMachineDefinition.ALLOCATED" parent="WBI.MonitoringEvent" situationType="Report" situationCategory="ReportCategory" reasoningScope="external">
            <Payload>
                <Data name="instanceID" type="string"/>
            </Payload>
        </Event>

        <Event name="WBI.BSM.StateMachineDefinition.RELEASED" parent="WBI.MonitoringEvent" situationType="Report" situationCategory="ReportCategory" reasoningScope="external">
             <Payload>
                <Data name="instanceID" type="string"/>
            </Payload>
        </Event>

        <Event name="WBI.BSM.Transition.ENTRY" parent="WBI.MonitoringEvent" situationType="Report" situationCategory="ReportCategory" reasoningScope="external">
             <Payload>
                <Data name="instanceID" type="string"/>
                <Data name="name" type="string"/>
                <Data role="input" type="primitive businessObject"  minOccurs="0" maxOccurs="unbounded"/> <!-- pojo -->
            </Payload>
        </Event>
        <!--
        opname, inputbo,
        -->
        <Event name="WBI.BSM.Transition.EXIT" parent="WBI.MonitoringEvent" situationType="Report" situationCategory="ReportCategory" reasoningScope="external">
             <Payload>
                <Data name="instanceID" type="string"/>
                <Data name="name" type="string"/>
                <Data role="output" type="primitive businessObject" minOccurs="0" maxOccurs="unbounded"/> <!-- pojo ?-->
            </Payload>
        </Event>

        <Event name="WBI.BSM.Transition.FAILURE" parent="WBI.ER" situationType="Report" situationCategory="ReportCategory" reasoningScope="external">
             <Payload>
                <Data name="instanceID" type="string"/>
                <Data name="name" type="string"/>
                <Data role="input" type="primitive businessObject"  minOccurs="0" maxOccurs="unbounded"/> <!-- pojo -->
            </Payload>
        </Event>

        <Event name="WBI.BSM.State.ENTRY" parent="WBI.MonitoringEvent" situationType="Report" situationCategory="ReportCategory" reasoningScope="external">
             <Payload>
                <Data name="instanceID" type="string"/>
                <Data name="name" type="string"/>
            </Payload>
        </Event>

        <Event name="WBI.BSM.State.EXIT" parent="WBI.MonitoringEvent" situationType="Report" situationCategory="ReportCategory" reasoningScope="external">
             <Payload>
                <Data name="instanceID" type="string"/>
                <Data name="name" type="string"/>
            </Payload>
        </Event>

        <Event name="WBI.BSM.State.FAILURE" parent="WBI.ER" situationType="Report" situationCategory="ReportCategory" reasoningScope="external">
             <Payload>
                <Data name="instanceID" type="string"/>
                <Data name="name" type="string"/>
            </Payload>
        </Event>

        <Event name="WBI.BSM.Guard.ENTRY" parent="WBI.MonitoringEvent" situationType="Report" situationCategory="ReportCategory" reasoningScope="external">
             <Payload>
                <Data name="instanceID" type="string"/>
                <Data name="name" type="string"/>
            </Payload>
        </Event>
        <!-- -->
        <Event name="WBI.BSM.Guard.EXIT" parent="WBI.MonitoringEvent" situationType="Report" situationCategory="ReportCategory" reasoningScope="external">
             <Payload>
                <Data name="instanceID" type="string"/>
                <Data name="name" type="string"/>
                <Data name="result" type="boolean"/>
            </Payload>
        </Event>
        <!-- boolean result -->
        <Event name="WBI.BSM.Guard.FAILURE" parent="WBI.ER" situationType="Report" situationCategory="ReportCategory" reasoningScope="external">
             <Payload>
                <Data name="instanceID" type="string"/>
                <Data name="name" type="string"/>
            </Payload>
        </Event>

        <Event name="WBI.BSM.Action.ENTRY" parent="WBI.MonitoringEvent" situationType="Report" situationCategory="ReportCategory" reasoningScope="external">
             <Payload>
                <Data name="instanceID" type="string"/>
                <Data name="name" type="string"/>
            </Payload>
        </Event>

        <Event name="WBI.BSM.Action.EXIT" parent="WBI.MonitoringEvent" situationType="Report" situationCategory="ReportCategory" reasoningScope="external">
             <Payload>
                <Data name="instanceID" type="string"/>
                <Data name="name" type="string"/>
            </Payload>
        </Event>

        <Event name="WBI.BSM.Action.FAILURE" parent="WBI.ER" situationType="Report" situationCategory="ReportCategory" reasoningScope="external">
             <Payload>
                <Data name="instanceID" type="string"/>
                <Data name="name" type="string"/>
            </Payload>
        </Event>

        <Event name="WBI.BSM.EntryAction.ENTRY" parent="WBI.MonitoringEvent" situationType="Report" situationCategory="ReportCategory" reasoningScope="external">
             <Payload>
                <Data name="instanceID" type="string"/>
                <Data name="name" type="string"/>
            </Payload>
        </Event>
        <!--  -->
        <Event name="WBI.BSM.EntryAction.EXIT" parent="WBI.MonitoringEvent" situationType="Report" situationCategory="ReportCategory" reasoningScope="external">
             <Payload>
                <Data name="instanceID" type="string"/>
                <Data name="name" type="string"/>
            </Payload>
        </Event>
        <!--  -->
        <Event name="WBI.BSM.EntryAction.FAILURE" parent="WBI.ER" situationType="Report" situationCategory="ReportCategory" reasoningScope="external">
             <Payload>
                <Data name="instanceID" type="string"/>
                <Data name="name" type="string"/>
            </Payload>
        </Event>
        <!-- exception -->
        <Event name="WBI.BSM.ExitAction.ENTRY" parent="WBI.MonitoringEvent" situationType="Report" situationCategory="ReportCategory" reasoningScope="external">
             <Payload>
                <Data name="instanceID" type="string"/>
                <Data name="name" type="string"/>
            </Payload>
        </Event>
        <!-- -->
        <Event name="WBI.BSM.ExitAction.EXIT" parent="WBI.MonitoringEvent" situationType="Report" situationCategory="ReportCategory" reasoningScope="external">
             <Payload>
                <Data name="instanceID" type="string"/>
                <Data name="name" type="string"/>
            </Payload>
        </Event>

        <Event name="WBI.BSM.ExitAction.FAILURE" parent="WBI.ER" situationType="Report" situationCategory="ReportCategory" reasoningScope="external">
             <Payload>
                <Data name="instanceID" type="string"/>
                <Data name="name" type="string"/>
            </Payload>
        </Event>

        <Event name="WBI.BSM.Timer.STARTED" parent="WBI.MonitoringEvent" situationType="Report" situationCategory="ReportCategory" reasoningScope="external">
             <Payload>
                <Data name="instanceID" type="string"/>
                <Data name="name" type="string"/>
                <Data name="duration" type="string"/>
            </Payload>
        </Event>

        <Event name="WBI.BSM.Timer.STOPPED" parent="WBI.MonitoringEvent" situationType="Report" situationCategory="ReportCategory" reasoningScope="external">
             <Payload>
                <Data name="instanceID" type="string"/>
                <Data name="name" type="string"/>
                <Data name="duration" type="string"/>
            </Payload>
        </Event>

         <Event name="WBI.ER" refName="WBI.ErrorReport" from="er:ITEvents"/>
</Events>
</EventSpec>